REM BEGIN COPYRIGHT
REM ************************************************************************
REM 
REM  Licensed Materials - Property of IBM
REM  5725-C94, 5725-C95, 5725-C96
REM  (C) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
REM  US Government Users Restricted Rights- Use, duplication or disclosure
REM  restricted by GSA ADP Schedule Contract with IBM Corp.
REM 
REM ************************************************************************
REM END COPYRIGHT
@ECHO off

SETLOCAL

CALL "%~dp0..\..\..\..\bin\setupCmdLine.bat" %*

SET myNodeNameExists=false

SET ORIG_DIR=%~dp0
SET RC=0
SET WASHOME_ARG=-DWAS_HOME=%WAS_HOME%
SET NODENAME_ARG=
SET SERVERNAME_ARG=
SET USERNAME_ARG=
SET PASSWORD_ARG=
SET COMMAND=

SET MAX_MEM=-Xmx320m
SET TW_PLATFORM=-Dteamworks.applicationServerPlatform="WebSphere 8.0"
SET TW_ENV_NAME=-Dcom.lombardisoftware.core.TWEnvironment.environmentName=ENVIRONMENT_PERFORMANCE_SERVER
SET PDW_TRUE=-DPERFORMANCEDW=true
SET LOGGING_ARG=-Djava.util.logging.config.file=%WAS_HOME%\BPM\Lombardi\tools\perfdw-tool\resources\logging.properties -Dtw.log4j.init=false

:processArguments
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

IF "%1"=="-serverName" SET SERVERNAME_ARG=-DserverName=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-nodeName" SET NODENAME_ARG=-DnodeName=%2 & SET NODENAME=%2 &SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-username" SET USERNAME_ARG=%2 & SHIFT & SHIFT & GOTO processArguments
IF "%1"=="-u" SET USERNAME_ARG=%2 & SHIFT & SHIFT & GOTO processArguments

IF "%1"=="-password" SET PASSWORD_ARG=%2 & SHIFT & SHIFT & GOTO processArguments
IF "%1"=="-p" SET PASSWORD_ARG=%2 & SHIFT & SHIFT & GOTO processArguments

IF NOT "%1"=="" SET COMMAND=%COMMAND% %1 & SHIFT & GOTO processArguments

IF "%COMMAND%"=="" GOTO help

set NODENAME=%NODENAME: =%
SET COMMAND_ARGS= -username %USERNAME_ARG% -password %PASSWORD_ARG%%COMMAND%
SET PROFILEPATH_ARG=-DprofilePath=%USER_INSTALL_ROOT%

SET THIS_CLASSPATH=%ORIG_DIR%
SET THIS_CLASSPATH=%WAS_HOME%\BPM\Lombardi\tools\perfdw-tool

SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\castor.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\harmony-concurrent-locks.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\jdom.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\langutil.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\log4j.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\psclnt.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\spring.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\svrcoreclnt.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\twant.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\twperfsvrtool.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\lib\utility.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\performance-data-warehouse\lib\twperfsvrclnt.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\process-server\twinit\lib\dbstructure.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\BPM\Lombardi\tools\perfdw-tool\resources

SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\lib\bootstrap.jar

SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.bpm.config.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.ffdc.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.hpel.logging.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.ws.admin.core.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.ws.emf.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.ws.prereq.commons-logging.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.ws.prereq.jaxrs.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.ws.proxy.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\com.ibm.ws.runtime.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\javax.j2ee.ejb.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\org.eclipse.core.runtime_.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\org.eclipse.emf.common.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\org.eclipse.emf.ecore.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\org.eclipse.equinox.common_.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\org.eclipse.equinox.registry.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\plugins\org.eclipse.osgi_.jar

FOR /F "delims=" %%i IN ('DIR /a-d /b /s "%WAS_HOME%\runtimes" 2^>NUL ^| findstr "com.ibm.ws.ejb.thinclient_" 2^>NUL') DO CALL :findThinClientJarFile %%i
IF "%THINCLIENT_JAR_FILE%"=="" (
  SET RC=-1
  ECHO.
  ECHO.
  ECHO EXIT:     Jar file com.ibm.ws.ejb.thinclient_*.jar does not exist under the 
  ECHO           %WAS_HOME%\runtimes directory.
  GOTO INTERIM_END
) ELSE (
  REM ECHO.
  REM ECHO.
  REM ECHO CONTINUE: Jar file com.ibm.ws.ejb.thinclient_*.jar exists at 
  REM ECHO           %THINCLIENT_JAR_FILE%
)
REM SET THIS_CLASSPATH=%THIS_CLASSPATH%;"%WAS_HOME%"\runtimes\com.ibm.ws.ejb.thinclient_8.5.0.jar
SET THIS_CLASSPATH=%THIS_CLASSPATH%;%THINCLIENT_JAR_FILE%

IF EXIST "%USER_INSTALL_ROOT%\config\cells\%WAS_CELL%\nodes\%NODENAME%" SET myNodeNameExists=true
IF "%myNodeNameExists%"=="false" (
  SET RC=-1
  ECHO EXIT:     nodeName "%NODENAME%" does not exist at
  ECHO           "%USER_INSTALL_ROOT%\config\cells\%WAS_CELL%\nodes\%NODENAME%"
  GOTO INTERIM_END
) ELSE (
  REM ECHO CONTINUE: nodeName "%NODENAME%" exists at
  REM ECHO           "%USER_INSTALL_ROOT%\config\cells\%WAS_CELL%\nodes\%NODENAME%"
)
FOR /F "delims=" %%i IN ('DIR /a-d /b /s "%USER_INSTALL_ROOT%\installedApps" 2^>NUL ^| findstr "twperfsvr-ejb.jar" 2^>NUL') DO CALL :findJarFile %%i
IF "%TWPERFSVR_JAR_FILE%"=="" (
  SET RC=-1
  ECHO EXIT:     Jar file twperfsvr-ejb.jar does not exist under the 
  ECHO           %USER_INSTALL_ROOT%\installedApps directory.
  GOTO INTERIM_END
) ELSE (
  REM ECHO CONTINUE: Jar file twperfsvr-ejb.jar exists at 
  REM ECHO           %TWPERFSVR_JAR_FILE%
)
SET THIS_CLASSPATH=%THIS_CLASSPATH%;%TWPERFSVR_JAR_FILE%

SET THIS_CLASSPATH=%THIS_CLASSPATH%;%JDBC_DRIVER_PATH%

REM PERF_SERVER_CONFIG=`find $USER_INSTALL_ROOT/config/cells -name "*/nodes/$PDW_NODE_NAME/servers/$PDW_SERVER_NAME/performance-data-warehouse"`
FOR /F "delims=" %%i IN ('DIR /ad /b /s "%USER_INSTALL_ROOT%\config\cells" 2^>NUL ^| findstr "performance-data-warehouse" 2^>NUL ^| findstr "%NODENAME%\server" 2^>NUL') DO CALL :findConfig %%i
IF "%PERF_SERVER_CONFIG%"=="" (
  SET RC=-1
  ECHO EXIT:     Cannot locate directory 
  ECHO           %USER_INSTALL_ROOT%\config\cells\**\performance-data-warehouse
  GOTO INTERIM_END
) ELSE (
  REM ECHO CONTINUE: performance-data-warehouse directory exists at
  REM ECHO           %PERF_SERVER_CONFIG% 
)

SET TW_SERVER_HOME=-Dteamworks.server.home=%PERF_SERVER_CONFIG%
SET TW_CONFIG_ROOT_HOME=-Dconfig.root=%PERF_SERVER_CONFIG%

REM ECHO %JAVA_HOME%\bin\java %MAX_MEM% %TW_SERVER_HOME% %TW_CONFIG_ROOT_HOME% %TW_PLATFORM% %TW_ENV_NAME% %PDW_TRUE% %LOGGING_ARG% %PROFILEPATH_ARG% %NODENAME_ARG% %SERVERNAME_ARG% -Dwas.install.root=%WAS_HOME% %CLIENTSAS% %JAASSOAP% %CLIENTSSL% -Dserver.root="%WAS_HOME%" -Dws.ext.dirs=%WAS_EXT_DIRS% -Djava.endorsed.dirs=%WAS_ENDORSED_DIRS% %USER_INSTALL_PROP% -classpath %WAS_CLASSPATH%;%THIS_CLASSPATH% com.ibm.ws.bootstrap.WSLauncher com.lombardisoftware.tools.tracking.ant.ToolLauncher %COMMAND_ARGS%
%JAVA_HOME%\bin\java %MAX_MEM% %TW_SERVER_HOME% %TW_CONFIG_ROOT_HOME% %TW_PLATFORM% %TW_ENV_NAME% %PDW_TRUE% %LOGGING_ARG% %PROFILEPATH_ARG% %NODENAME_ARG% %SERVERNAME_ARG% -Dwas.install.root=%WAS_HOME% %CLIENTSAS% %JAASSOAP% %CLIENTSSL% -Dserver.root="%WAS_HOME%" -Dws.ext.dirs=%WAS_EXT_DIRS% -Djava.endorsed.dirs=%WAS_ENDORSED_DIRS% %USER_INSTALL_PROP% -classpath %WAS_CLASSPATH%;%THIS_CLASSPATH% com.ibm.ws.bootstrap.WSLauncher com.lombardisoftware.tools.tracking.ant.ToolLauncher %COMMAND_ARGS%

SET RC=%ERRORLEVEL%
GOTO END

:nodeNameExists
SET myNodeNameExists=true 
GOTO INTERIM_END

:findJarFile
SET str1=%1
IF NOT x%str1:twperfsvr-ejb.jar=%==x%str1% SET TWPERFSVR_JAR_FILE="%1"
GOTO INTERIM_END

:findThinClientJarFile
SET str1=%1
echo DWS111 %1
IF NOT x%str1:com.ibm.ws.ejb.thinclient_=%==x%str1% SET THINCLIENT_JAR_FILE="%1"
GOTO INTERIM_END

:findConfig
SET str2=%1
SET str3=%str2:~-27%
IF NOT x%str3:performance-data-warehouse=%==x%str3% SET PERF_SERVER_CONFIG="%1"
GOTO INTERIM_END

:help
ECHO Usage:
ECHO.
ECHO    perfDWTool.bat [options...] ^<command^>
ECHO.
ECHO Options:
ECHO    -?, -help                                  This help message
ECHO    -u ^<username^>, -username ^<username^>    user name of the performance DW user
ECHO    -p ^<password^>, -password ^<password^>    user password (unencrypted)
ECHO    -nodeName ^<name^>                         node name in ND environment
ECHO    -serverName ^<name^>                       server name in ND environment
ECHO.
ECHO Commands:
ECHO  pending [schema-command-args] [-groups tracking-group-name-1 tracking-group-name-2 ...]
ECHO  archive [snapshot-id-1 snapshot-id-2 ...]
ECHO  restore [snapshot-id-1 snapshot-id-2 ...]
ECHO  prune [prune-command-args]
ECHO.
ECHO Prune Command Args:
ECHO  -daysOld number-of-days-old
ECHO.
ECHO Schema Command Args:
ECHO  -preview output-file-name
ECHO  -prepare output-file-name
ECHO  -execute
GOTO end

:interim_end
IF "%RC%"=="0" (
  ECHO. >NUL
) ELSE (
  ECHO FAIL: perfDWTool did not complete successfully. 
  ECHO       See the previous message^(s^) for the cause.
  ECHO.
  ECHO.
)
EXIT /B %RC%
ENDLOCAL

:end
IF "%RC%"=="0" (
  REM ECHO.
  REM ECHO.
  REM ECHO SUCCESS: perfDWTool completed successfully.
) ELSE (
  REM ECHO.
  REM ECHO.
  REM ECHO FAIL: perfDWTool did not complete successfully. 
  REM ECHO       See the previous message or the 
  REM ECHO       perfdw-tool.log file in this directory.
  REM ECHO       for the cause.
  REM ECHO.
)
EXIT /B %RC%
ENDLOCAL
